VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "stActions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements ISmartTagAction
Implements ISmartTagAction2

Private Property Get ISmartTagAction_ProgId() As String
    ' The language independent unique identifier
    ' should correspond to the progid of this DLL.
    ISmartTagAction_ProgId = "AccessSmartTag.stActions"
End Property

Private Property Get ISmartTagAction_Name(ByVal lcid As Long) As String
    ' Short phrase describing the DLL
    ISmartTagAction_Name = "Demo Smart Tag Actions"
End Property

Private Property Get ISmartTagAction_Desc(ByVal lcid As Long) As String
  ' Longer description of the DLL
  ISmartTagAction_Desc = _
   "This is a Sample SmartTag used to open Forms and Reports."
End Property

Private Property Get ISmartTagAction_SmartTagCount() As Long
  ' The count of the smart tag types. 1 in this case.
  ISmartTagAction_SmartTagCount = 1
End Property

Private Property Get ISmartTagAction_SmartTagName( _
 ByVal ismarttag As Long) As String
  ' SmartTag type names are always in the format of namespaceURI#tagname.
  ' The ismarttag = 1 check isn't strictly necessary since
  ' There is only 1 smart tag type and it will only get called once.
  If (ismarttag = 1) Then
    ISmartTagAction_SmartTagName = _
     "schemas-microsoft-com/smarttag/northwind#openform"
  End If
End Property

Private Property Get ISmartTagAction_SmartTagCaption( _
    ByVal ismarttag As Long, ByVal lcid As Long) As String
     ' Specify the caption
     ISmartTagAction_SmartTagCaption = "Access Smart Tag Demo"
End Property

Private Property Get ISmartTagAction_VerbCount(ByVal bstrName As String) As Long
    ' The number of verbs (actions) in this smart tag
    If (bstrName = "schemas-microsoft-com/smarttag/northwind#openform") Then
        ISmartTagAction_VerbCount = 2
    End If
End Property

Private Property Get ISmartTagAction_VerbID( _
 ByVal bstrName As String, ByVal iVerb As Long) As Long
    ' Return iVerb back to the action client as the unique ID
    ISmartTagAction_VerbID = iVerb
End Property

Private Property Get ISmartTagAction_VerbCaptionFromID(ByVal idVerb As Long, ByVal bstrAppName As String, ByVal lcid As Long) As String

End Property

Private Property Get ISmartTagAction_VerbNameFromID(ByVal idVerb As Long) As String
  ' The name for the string that gets used internally to represent the verb ID.
  Select Case idVerb
      Case 1
        ISmartTagAction_VerbNameFromID = "openCustomers"
      Case 2
        ISmartTagAction_VerbNameFromID = "openReport"
      Case Else
        ISmartTagAction_VerbNameFromID = ""
  End Select
End Property

Private Property Get ISmartTagAction2_VerbCaptionFromID2( _
 ByVal VerbID As Long, ByVal ApplicationName As String, _
 ByVal LocaleID As Long, ByVal Properties As SmartTagLib.ISmartTagProperties, _
 ByVal Text As String, ByVal Xml As String, ByVal Target As Object) As String
    ' This If statement is technically unnecessary since the
    ' calls should only be with the IDs supplied in the VerbID
    ' property. Still, it's better to be robust and prevent unintended
    ' behavior by misbehaving action clients.
    If (VerbID = 1) Then
        ' Use "///" to get cascading menus
        ISmartTagAction2_VerbCaptionFromID2 = _
         "Smart Tag Actions///Open Customer Form"
    ElseIf (VerbID = 2) Then
        ISmartTagAction2_VerbCaptionFromID2 = _
         "Smart Tag Actions///Open Customer Report"
    End If
End Property

Public Sub ISmartTagAction_InvokeVerb(ByVal idVerb As Long, ByVal bstrAppName As String, ByVal pdispTarget As Object, ByVal pfp As SmartTagLib.ISmartTagProperties, ByVal bstrText As String, ByVal bstrXML As String)

End Sub

Private Sub ISmartTagAction2_InvokeVerb2( _
 ByVal VerbID As Long, ByVal ApplicationName As String, _
 ByVal Target As Object, ByVal Properties As SmartTagLib.ISmartTagProperties, _
 ByVal Text As String, ByVal Xml As String, ByVal LocaleID As Long)

On Error GoTo HandleErr:
    ' Set a variable to point to the Target argument, which provides the
    ' Access control the smart tag is attached to
    Dim cb As Access.Control
    Set cb = Target
    
    ' This smart tag only works when attached to CustomerID, so provide
    ' error msg if attached to some other control/field.
    If cb.ControlSource <> "CustomerID" Then
        MsgBox "This action only works if you run it on the Customer ID field.", _
         vbOKOnly, "Smart Tag Error"
         GoTo ExitHere
    Else
        ' Grab the Application object from the Target's Application property.
        Dim app As Access.Application
        Set app = cb.Application
    End If

    If VerbID = 1 Then
        ' Set a reference to the Application object's CurrentDb property
        ' to gain access to DAO objects
        Dim db As DAO.Database
        Dim rs As DAO.Recordset
        Set db = app.CurrentDb
        
        ' Create a recordset that returns the total number of orders
        ' for the CustomerID supplied by the Target's Value property
        ' and stuff it in the OpenArgs when opening the form.
        Dim strQry As String
        Dim strOrders As String
        strQry = "SELECT Count(*) AS NumOrders FROM Orders WHERE CustomerID='" _
         & cb.Value & "';"
        Set rs = db.OpenRecordset(strQry)
        If Not rs.EOF Then
            strOrders = "Total number of orders: " & rs!NumOrders
        Else
            strOrders = "No orders for this customer"
        End If
        rs.Close
        
        app.DoCmd.OpenForm "Customers", _
         WhereCondition:="[CustomerID] = '" & cb.Value & "'", _
         OpenArgs:=strOrders
    
    ElseIf VerbID = 2 Then
        app.DoCmd.OpenReport "rptCustomers", _
         View:=acViewPreview, _
         WhereCondition:="[CustomerID] = '" & cb.Value & "'"
    End If
   
ExitHere:
   Exit Sub
   
HandleErr:
   MsgBox Err.Number & " " & Err.Description, _
    vbCritical, "Error in AccessSmartTag.ISmartTagAction2_InvokeVerb2"
   Resume ExitHere
End Sub

Private Property Get ISmartTagAction2_IsCaptionDynamic(ByVal VerbID As Long, ByVal ApplicationName As String, ByVal LocaleID As Long) As Boolean

End Property

Private Property Get ISmartTagAction2_ShowSmartTagIndicator(ByVal VerbID As Long, ByVal ApplicationName As String, ByVal LocaleID As Long) As Boolean
    ISmartTagAction2_ShowSmartTagIndicator = True
End Property

Private Sub ISmartTagAction2_SmartTagInitialize(ByVal ApplicationName As String)

End Sub

