Imports Access = Microsoft.Office.Interop.Access
Imports System.Data.OleDb

Public Class PrintArtistReport
    Inherits System.Windows.Forms.Form

    ' You will need to edit the strDb value to correspond
    ' to the location of the 17-06.mdb database on your system.
    Private Const strDb As String = "D:\Books\AccessCookBook2003\ch17\17-06.mdb"
    Private Const strRpt As String = "rptArtistAlbums"
#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents cboArtist As System.Windows.Forms.ComboBox
    Friend WithEvents cmdRunReport As System.Windows.Forms.Button
    Friend WithEvents lblArtist As System.Windows.Forms.Label
    Friend WithEvents chkPreview As System.Windows.Forms.CheckBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.cboArtist = New System.Windows.Forms.ComboBox
        Me.lblArtist = New System.Windows.Forms.Label
        Me.cmdRunReport = New System.Windows.Forms.Button
        Me.chkPreview = New System.Windows.Forms.CheckBox
        Me.SuspendLayout()
        '
        'cboArtist
        '
        Me.cboArtist.Location = New System.Drawing.Point(72, 32)
        Me.cboArtist.Name = "cboArtist"
        Me.cboArtist.Size = New System.Drawing.Size(128, 21)
        Me.cboArtist.TabIndex = 0
        '
        'lblArtist
        '
        Me.lblArtist.Location = New System.Drawing.Point(24, 32)
        Me.lblArtist.Name = "lblArtist"
        Me.lblArtist.Size = New System.Drawing.Size(48, 24)
        Me.lblArtist.TabIndex = 1
        Me.lblArtist.Text = "Artist:"
        '
        'cmdRunReport
        '
        Me.cmdRunReport.Location = New System.Drawing.Point(72, 96)
        Me.cmdRunReport.Name = "cmdRunReport"
        Me.cmdRunReport.Size = New System.Drawing.Size(128, 32)
        Me.cmdRunReport.TabIndex = 2
        Me.cmdRunReport.Text = "Run Report"
        '
        'chkPreview
        '
        Me.chkPreview.Checked = True
        Me.chkPreview.CheckState = System.Windows.Forms.CheckState.Checked
        Me.chkPreview.Location = New System.Drawing.Point(24, 56)
        Me.chkPreview.Name = "chkPreview"
        Me.chkPreview.Size = New System.Drawing.Size(176, 24)
        Me.chkPreview.TabIndex = 3
        Me.chkPreview.Text = "Preview report before printing"
        '
        'PrintArtistReport
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(216, 141)
        Me.Controls.Add(Me.chkPreview)
        Me.Controls.Add(Me.cmdRunReport)
        Me.Controls.Add(Me.lblArtist)
        Me.Controls.Add(Me.cboArtist)
        Me.Name = "PrintArtistReport"
        Me.Text = "PrintArtistReport"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub cmdRunReport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdRunReport.Click
        Dim accApp As Access.Application
        Dim strWhere As String

        ' Construct where clause
        strWhere = "ArtistId = " & cboArtist.SelectedValue

        ' Instantiate the Access application
        accApp = New Access.Application

        'Open database
        accApp.OpenCurrentDatabase(strDb)

        If chkPreview.Checked Then
            ' Make Access visible and open report
            ' in print preview.

            ' Display report in Print Preview.
            accApp.DoCmd.OpenReport(strRpt, Access.AcView.acViewPreview, , strWhere)

            ' Make Access visible so you can see the report.
            ' It will be up to the user to shut down Access.
            ' However, Access will not be released from memory until
            ' this application shuts down.
            accApp.Visible = True
        Else
            ' Go ahead and print directly. No need
            ' to make Access visible or to leave open.

            ' Print report to printer and quit Access.
            accApp.DoCmd.OpenReport(strRpt, Access.AcView.acViewNormal, , strWhere)
            accApp.DoCmd.Quit()

            ' Force Access to shutdown now.Unless you include this code, 
            ' Access won't be removed from memory until this app shuts down.
            System.Runtime.InteropServices.Marshal.ReleaseComObject(accApp)
        End If

    End Sub

    Private Sub PrintArtistReport_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' This code populates the cboArtists control
        ' with the list of artists from the 17-06.mdb database.

        Dim cnx As OleDbConnection = New OleDbConnection( _
         "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & strDb)

        Dim strSql As String = "SELECT ArtistId, ArtistName " & _
         "FROM tblArtists ORDER BY ArtistName"

        Dim daArtists As OleDbDataAdapter = New OleDbDataAdapter(strSql, cnx)

        Dim dsArtists As DataSet = New DataSet
        daArtists.Fill(dsArtists, "Artists")

        cboArtist.DataSource = dsArtists.Tables("Artists").DefaultView
        cboArtist.DisplayMember = "ArtistName"
        cboArtist.ValueMember = "ArtistId"
    End Sub

End Class
