Imports System

Public Class Circle
    ' NOTE: This class contains a 
    ' parameterized constructor which
    ' prevents it from being called
    ' by a COM program. 

    Private RadiusVal As Double

    Public Sub New(ByVal Radius As Double)
        ' This constructor takes a parameter
        RadiusVal = Radius
    End Sub

    Public Property Radius() As Double
        Get
            Return RadiusVal
        End Get
        Set(ByVal Value As Double)
            RadiusVal = Value
        End Set
    End Property

    Public Function Area() As Double
        Return Radius ^ 2 * System.Math.PI
    End Function

    Public Function Circumference() As Double
        Return 2 * Radius * System.Math.PI
    End Function
End Class

Public Class CircleCOM
    Inherits Circle


    ' PURPOSE: This derived class provides 
    ' a way to call Circle from COM
    ' by instantating Circle for us.
    ' CircleCOM's constructor has no
    ' parameters.

    Sub New()
        ' Call base class' constructor
        ' with dummy radius value.
        MyBase.New(1)
    End Sub

End Class

